CIELRCPT - Editorial

PROBLEM LINK

Practice
Contest

DIFFICULTY

CAKEWALK

PREREQUISITES

Greedy Algorithms

PROBLEM

You need to find the representation of a given integer N as a sum of powers of two up to 211 with the smallest number of summands (repetitions in representation are allowed).

QUICK EXPLANATION

The problem can be solved by greedy algorithm: at each step we should take the largest possible menu that we can. To prove this noticed that if we order two equal menus, say 4 and 4, then we can order instead one menu of cost 8. In this problem you can implement this approach in any way you like but the easiest and fastest way gives the following pseudo-code:

res = 0
for i = 11 to 0
  res = res + N div 2i
  N = N mod 2i

EXPLANATION

At first we reveal the answer and then will prove it in detail. Write N as Q * 2048 + R, where Q and R are non-negative integers and R < 2048. Then the answer is Q + bitCountĀ®, where bitCount(X) is the number of ones in binary representation of X. If R = 2h[1] + 2h[2] + ā€¦ + 2h[K] is a binary representation of R then the optimal representation of N is N = 2048 + ā€¦ + 2048 + 2h[1] + 2h[2] + ā€¦ + 2h[K] where we have Q copies of 2048. Letā€™s call this approach formula approach.

Another way to come up with this answer is to use Greedy Algorithm. That is, at each step you should take the largest possible summand among {1, 2, 4, 8, ā€¦, 2048} that is not greater than the current value of N and then subtract it from N. In fact, this problem is a special case of Change-making problem and in general it should be solved using Dynamic Programming or Integer Linear Programming but this set of coin values is special and admit using of Greedy Algorithm as we will see below.

Now we discuss why both of these approaches are correct.


#1. Formula Approach.

Letā€™s prove that formula approach is correct. Consider some representation of N as a sum of allowed powers of two. Let there is exactly C[K] occurrences of 2K in this representation. Then we have

N = C[0] * 1 + C[1] * 2 + C[2] * 4 + ā€¦ + C[11] * 2048

Note that the total number of summands here is C[0] + C[1] + ā€¦ + C[10] + C[11]. Assume that for some K < 11 we have C[K] >=2, that is, we have at least two copies of 2K in the representation of N. Since K < 11 then the price 2K+1 is allowed. Hence we can replace two copies of 2K by one copy of 2K+1 not changing the value of sum but decreasing total number of summands. Thus, for optimal representation we should have

**C[K] <= 1** for all **K < 11**. Ā  Ā  Ā  Ā  Ā  Ā  Ā  Ā  Ā  Ā  Ā  Ā  (1)

We will show that under the constraints (1) representation of N is uniquely determined. Of course this unique representation will be the optimal one.

At first note that

R = C[0] * 1 + C[1] * 2 + C[2] * 4 + ā€¦ + C[10] * 1024 <= 1 + 2 + 4 + ā€¦ + 1024 = 2047 < 2048.

Hence

2048 * C[11] <= N < 2048 * (C[11] + 1)

or

C[11] <= N / 2048 < C[11] + 1

which means by one of the definition of floor function that C[11] = floor(N / 2048) = Q. So C[11] is uniquely determined under the constraints (1) and equals to Q.

Further note that due to (1) C[10]C[9]ā€¦C[1]C[0] is a binary representation of R and hence C[0], C[1], ā€¦, C[10] are also uniquely determined under the constraints (1).

Thus we have found this unique representation.

Next we have bitCountĀ® = C[0] + C[1] + ā€¦ + C[10]. Hence the total number of summands in this representation is Q + bitCountĀ® as was announced earlier. The complexity of this method is O(K), where K = 12 is the total number of powers of two that we are allowed to use.


#2. Greedy Approach.

Now letā€™s see why greedy approach produces the same solution. Clearly at first several steps we will take the 2048 until we get a number strictly less than 2048. Then we will consider powers of two in descending order starting from 1024 and take the current power of two if it is not greater than the current value of N. It is quite clear that this process generates exactly the binary representation of N. Thus the whole representation coincides with the constructed above.

There are several ways how to implement this algorithm in this problem. First one is simple but slower in general. Namely, we have an outer loop of the form while (N > 0). Then at each iteration of this loop we simply check in one loop all allowed powers of two in descending order until we find the power of two, say 2X, that is not greater than the current value of N. After that we decrease N by 2X and increase answer by 1. The complexity of this approach is O(N / 2K-1 + K2) in the worst test case. This is because at first N / 2K-1 steps we have only one iteration of inner loop (we break at 2048) and then we have at most K steps for each of which we have at most K steps in the inner loop.

In second method we swap outer and inner loop of the first method. So we iterate over allowed powers of two in descending order and for each power of two we have an inner loop of the form while (N >= 2X) in the body of which we do the same as for the first method, that is, decrease N by 2X and increase answer by 1. The complexity of this method is O(N / 2K-1 + K). Strictly speaking the number of basic operations in this method is O(answer + K). N / 2K-1 + K is an upper bound for the answer.

Analyzing second implementation of the greedy approach it is easy to see how to make it faster. For each power of two we have the following inner loop

while N >= 2X do
  N = N - 2X
  res = res + 1

Clearly this equivalent to

  res = res + N div 2X
  N = N mod 2X

Thus we obtain third implementation of the greedy algorithm with complexity O(K).


#3. Dynamic Programming Approach.

Now letā€™s consider another approach that allows to find the answer for arbitrary set of coin values in reasonable time. We will use dynamic programming. Let d1, ā€¦, dK be the set of allowed coin values (they all are positive). Denote by FĀ§ the minimal number of coins needed to represent P by this set of coins (repetitions in representation are allowed). Clearly F(0) = 0. Consider some value of P > 0. Then it is quite clear that

**F(P) = min{F(P - d1), F(P - d2), ..., F(P - dK)} + 1.** Ā  Ā  Ā  Ā  Ā  Ā  (2)

where we set for convenience F(x) = INF for x < 0 (INF is some very large number). But letā€™s prove this formally.

At first consider the optimal representation for P. Let it be P = A1 + ā€¦ + AL where L = FĀ§ and each Ai is of course equal to one of dj. Then A2 + ā€¦ + AL is some representation of P ā€“ A1 of the length L ā€“ 1. By definition of F(P ā€“ A1) we have
L ā€“ 1 >= F(P ā€“ A1)
or
FĀ§ >= F(P ā€“ A1) + 1.
Since A1 is equal to one of dj then
F(P ā€“ A1) >= min{F(P - d1), F(P - d2), ā€¦, F(P - dK)}.
Combining the last two inequalities we get the first part of (1). Namely

**F(P) >= min{F(P - d1), F(P - d2), ..., F(P - dK)} + 1.** Ā  Ā  Ā  Ā  Ā  Ā  (3)

Now let dj be those coin value for which F(P - dj) is minimal among F(P - d1), F(P - d2), ā€¦, F(P - dK). Let B1, ā€¦, BZ be the optimal representation for P - dj. That is P - dj = B1 + ā€¦ + BZ and Z = F(P ā€“ dj). But then P = dj + B1 + ā€¦ + BZ. So P has a representation of the length Z + 1 which by definition of FĀ§ means that

**F(P) <= Z + 1 = F(P ā€“ dj) + 1 = min{F(P - d1), F(P - d2), ..., F(P - dK)} + 1.** Ā  Ā  Ā  Ā  Ā  Ā  (4)

Now (2) follows from (3) and (4). Formula (2) allows to find all values F(0), F(1), ā€¦, F(N) in a simple double loop. So F(N) can be found in O(N * K) time with O(N + K) memory.

SETTERā€™S SOLUTION

Can be found here.
Setter used the third implementation of the greedy approach described above.

TESTERā€™S SOLUTION

Can be found here.
Tester solution has complexity O(log N) (if we replace i <= 17 by 2i <= h). In this solution he implicitly deals with more natural version of the problem where all powers of two are allowed, that is, we simply need to find bitCount(h). To get the correct answer he increase answer by 2i-11 instead of 1 for each power of two that is greater than 211 and presented in the binary expansion of h.

RELATED PROBLEMS

Greedy Change (Codeforces Beta Round #10, problem E)
Let Me Count The Ways (UVA 357)

4 Likes

Can anyone tell me why this Python solution gets runtime error?
http://www.codechef.com/viewsolution/1187366

1 Like

I am not familiar with Python but it seems that you are using file for input. You should read from the standard input and output to the standard output.

I actually am using standard input. It reads from an input file on my computer (for testing), but if that file doesnā€™t exist (when I submit) it uses raw_input() instead. Iā€™ve tested this method on the codechef judge and it works for other problems, so I donā€™t understand why it gets runtime error now.

The reason is:
Traceback (most recent call last):
File ā€œprog.pyā€, line 17, in
NameError: name ā€˜binā€™ is not defined

1 Like

That doesnā€™t make senseā€¦ bin is a built-in function, how could it not be defined? I thought it must be something with the input because this solution http://www.codechef.com/viewsolution/1187415 got accepted.

You will be angry, but your code works - http://www.codechef.com/viewsolution/1191924 , is there problem with whitespace, PY is ā€œwhitespace sensitiveā€, isnā€™t it?

1 Like

That link doesnā€™t work, but I see that you got my solution accepted. So I tried it myself and got runtime error http://www.codechef.com/viewsolution/1191926. (this is the exact same code that you got accepted, right?) And yeah, python is whitespace-sensitive, but I donā€™t see how that could be the problem because the solution I posted above got accepted. Something really weird is going onā€¦

problem was with comma in link, try again, is your editor replacing multiple spaces with one tab (but it is just a tip)?

@anton_lunyov, can you make diff of these two solutions on filesystem?

wow this is total B.S. How does the exact same code get accepted for betlista but runtime error for me???

hi @anton_lunyovā€¦could you please explain the dynamic programming part more clearly ā€¦i dont understand how you got eqn (2) and also what Ai stands for and how L=FĀ§ā€¦please explain the stepsā€¦thanks

1 Like

note on my code: initialize the array of power 2, starting from 0 goes to 11. after getting p, starting from the maximum value of array(here 2048, index is arr[11]=2048) and check if p is equal to or greater than that value. if so, p=p-arr[i], count++. i also increased i++ so that continues from the index last visited. thnx

Convert into binary and count the number of oneā€™s . That is the answer

No. Your solution will not work for, suppose, 4096. You have to first divide p with 2048 and then count number of one in the remainder.

1 Like

#include<stdio.h>

int main()
{
short unsigned int t,i,n;
long unsigned int p;
scanf("%u",&t);
for(i=0;i<t;i++)
{
scanf("%ld",&p);
n = p/2048 + (p%2048)/1024 + ((p%2048)%1024)/512 + (((p%2048)%1024)%512)/256 + ((((p%2048)%1024)%512)%256)/128 + (((((p%2048)%1024)%512)%256)%128)/64 + ((((((p%2048)%1024)%512)%256)%128)%64)/32 + (((((((p%2048)%1024)%512)%256)%128)%64)%32)/16 + ((((((((p%2048)%1024)%512)%256)%128)%64)%32)%16)/8 + (((((((((p%2048)%1024)%512)%256)%128)%64)%32)%16)%8)/4 + ((((((((((p%2048)%1024)%512)%256)%128)%64)%32)%16)%8)%4)/2 + ((((((((((p%2048)%1024)%512)%256)%128)%64)%32)%16)%8)%4)%2;
printf("%u\n",n);
}
return 0;
} 

runtime errorā€¦ please help !!

Write N as Q * 2048 + R, where Q and R are non-negative integers and R < 2048. Then the answer is Q + bitCountĀ®, where bitCount(X) is the number of ones in binary representation of X.

This is my doubt as if N is less than 2048, we cant express the same as Q* 2048+ R as we are told that Q and R are integers( not a fraction ).

how to solve this problem in easy way please tell meā€¦

can somebody please help me with my code here is the link : http://ideone.com/NovXIt

i am getting wrong answer .

Why Isnā€™t THis Approach Working ??

    #include <iostream>
#include <cmath>
using namespace std;
typedef long long int ll;
int main() {
	ll t;
	cin>>t;
	while(t--)
	{
	    ll ans=0,p,lpow;
	    cin>>p;
	    while(p>0)
	    {
	        
	        lpow = log2(p);
	        
	        p-=pow(2,lpow);
	        ans++;
	       
	    }
	    cout<<ans<<endl;
	}
	return 0;
}